#include <iostream>
#include <cmath>

using namespace std;


int szamol()
{
    int n,m;
    cin>>n>>m;


    long long int a[n], b[m], mink=0, mar;

    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        if(i!=0)
            if(mink==0)
                {mink=abs(a[1]-a[0]);
                 mar=a[0]%mink;
                }
            else if(abs(a[i]-a[i-1])<mink)
                {mink=abs(a[i]-a[i-1]);
                 mar=a[i-1]%mink;
                }
    }

    for(int i=0;i<m;i++)
        cin>>b[i];

    for(int i=0;i<n;i++)
        if(a[i]%mink!=mar)
             return 0;



    for(int i=0;i<m;i++)
        if(b[i]%mink==mar)
             return 0;



    return 1;



}

int main(
{

    int t;
    cin>>t;

    int a[t];
    for(int i=0;i<t;i++)
         a[i]=szamol();

    for(int i=0;i<t;i++)
        cout<<a[i]<<endl;





    return 0;
}